<?php
class UptimeMasterConfController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','Check','GenerateFiles');
	var $uses=array('Group', 'Host', 'Rlthstgrp','Grpauth', 'Authority','Rltuserauth','User','Configure','Validation',
	'Employee','Employeeaccount','Hsttime', 'Hstacc','Employeeadacc', 'Oldaccount', 'Activedirectory','Oldhstaccount');
	var $layout='uptime';
	function beforeFilter()
	{
		parent::beforeFilter();
		$this->pageTitle =__('menu_uptime',$retrun=true); 
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		elseif(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
	}
	function index($errorMessage = null)
	{
		$glist = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
		$this->set('glist',$glist);
		
		//グループ所属の社員ID
		$group_ids = "";
		foreach($glist as $key => $g){
			$group_ids .= $key.",";
		}
		$group_ids = rtrim($group_ids, ","); 
		$fields = array('Employee.id', 
		'concat(Employee.id_name, " ", Employee.name) as Employee__name', 
		'Employee.id_name');
		$criteria[]="Employee.group_id in (".$group_ids.")";
		$elist = $this->Employee->findAll($criteria, $fields, "Employee.id_name", null, 1);
		if(!empty($elist)){
			$keys = Set::extract($elist, '{n}.Employee.id');
			$vals = Set::extract($elist, '{n}.Employee.name');
			$elist = array_combine($keys, $vals);
		}
		$elist = array(""=>"全て") + $elist;
		//debug($elist);
		$this->set('elist',$elist);
		
		if(!empty($errorMessage))
			$this->set('errorMessage',$errorMessage);
	}
	
	function lists($mode=null)
	{
		$this->layout="ajax";
	
		$group_id = $this->data['Employee']['group_id'];
		$empl_id = $this->data['Employee']['id'];

		///取得条件設定
		$asso = array(
			'Group : groups : LEFT' => array('Employee.group_id = Group.id'),
			'Employeeaccount : employeeaccounts : LEFT' => array('Employeeaccount.employee_id = Employee.id'),
			'Host : hosts : LEFT' => array('Host.id = Employeeaccount.host_id'),
			'Hstacc : hstaccs : LEFT' => array(
				'Employeeaccount.account = Hstacc.account',
				"Hstacc.account != ''",				
				'Employeeaccount.host_id = Hstacc.host_id'),
			'Employeeadacc : employeeadaccs : LEFT' => array('Employeeadacc.employee_id = Employee.id'),
			'Hstacc2 : hstaccs : left' => array(
				"Employeeadacc.account like concat(Hstacc2.domain,'%\\\',Hstacc2.account)",
				'Host.id = Hstacc2.host_id'),
				
		) ;
		
		//取得項目
		$fields = array(
		'Employee.id',
		'Employee.id_name',
		'Employee.name',
		'Employee.enabled',
		'Group.group_name',
		//'Host.host_name',
		'GROUP_CONCAT(Host.host_name order by Employeeaccount.number separator ":") as Host__host_name',
		'GROUP_CONCAT(Employeeaccount.account order by Employeeaccount.number separator ":") as Employeeaccount__account',
		'GROUP_CONCAT(Employeeaccount.exist order by Employeeaccount.number separator ":") as Employeeaccount__exist',
		'GROUP_CONCAT(Hstacc.account is not null order by Employeeaccount.number separator ":") as Employeeaccount__exist2',
		'Employeeadacc.account',
		'sum(Hstacc2.account is not null) as Employeeadacc__exist',
		);
		
		$criteria[] = "1=1";
		//グループの指定
		if($group_id != 1 && isset($group_id)){
			$group_ids = "";
			$glist = $this->Grpauth->getChildrenByParent($group_id);
			foreach($glist as $key => $g){
				$group_ids .= $key.",";
			}
			$group_ids = rtrim($group_ids, ","); 
			$criteria[]="Employee.group_id in (".$group_ids.")";
		}
		//社員IDを指定
		if($empl_id != ""){
			$criteria[]="Employee.id =".$empl_id;
		}
		$criteria['GROUP BY']="Employee.id";
		
		//取得
		$this->Pagination->show = 50;
		list($order,$limit,$page) = $this->Pagination->init($criteria, null, 
						array('ajaxDivUpdate'=>'lists', 'url'=>'/uptime_master_conf/lists', 'modelClass'=>'Employee', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 'sortBy' => $this->Lv->sortBy(
				'Employee.id_name',
				'Employee.name',
				'Group.group_name',
				'Host.host_name',
				'Employeeadacc.account')));
		if($mode == "csv"){
			$Employees = $this->Employee->findByAsso($criteria, $fields, $order, null, null, $asso);
			$count = 3;
			foreach($Employees as &$record){
				$accs = explode(":", $record['Employeeaccount']['account']);
				for($i = 0; $i < $count; $i++){
					$record['Employeeaccount']['account'.$i] = isset($accs[$i]) ? $accs[$i] : "";
				}
				$hosts = explode(":", $record['Host']['host_name']);
				for($i = 0; $i < $count; $i++){
					$record['Host']['host_name'.$i] = isset($hosts[$i]) ? $hosts[$i] : "";
				}
				$exists = explode(":", $record['Employeeaccount']['exist']);
				$exists2 = explode(":", $record['Employeeaccount']['exist2']);
				for($i = 0; $i < $count; $i++){
					$record['Employeeaccount']['exist'.$i] = isset($exists2[$i]) ? $exists2[$i] : (isset($exists[$i]) ? $exists[$i] : "");
					if(empty($accs[$i]))
						$record['Employeeaccount']['exist'.$i] = "";
				}
			
				if($record['Employee']['enabled'] == '1')
					$record['Employee']['enabledstr'] = __('enabled', $return = true);
				else
					$record['Employee']['enabledstr'] = __('disabled', $return = true);
			}
			$this->csvdown($Employees);exit();
			
		}else{
			$Employees = $this->Employee->findByAsso($criteria, $fields, $order, $limit, $page, $asso);
			$this->set('data',$Employees);
			//debug($Employees);
			$this->render('lists');
		}
		
	}
	
	function csvdown($data = array())
	{
		require_once( 'csv/DlFactory.php' );
		$csv = DlFactory::create("uptime_masters");
		$csv->sendCSVFile($data,$this->data, __('csv_name',$return = true));
		exit;
	}
	
	function form($eid = null)
	{
		$this->layout='ajax';
		$criteria = array();
		
		$group_id = $this->_getUserGroup();
		
		$glist = $this->Grpauth->getChildrenByParent($group_id);
		$this->set('glist',$glist);
		
		$hostlist = $this->Rlthstgrp->getHostsByGroup($group_id);
		//他に登録されているホストをリスト化
		$host_ids = "";
		foreach($hostlist as $key => $h){
			$host_ids .= $key.",";
		}
		$host_ids = rtrim($host_ids, ",");
		$fields = array('Employeeaccount.host_id');
		$criteria[]="Employeeaccount.host_id in (".$host_ids.")";
		if(is_numeric($eid))
			$criteria[]="Employeeaccount.employee_id != ".$eid;
		$hlist = $this->Employeeaccount->findAll($criteria, $fields, null, null, 1);
		$this->set('registred',$hlist);
		//var_dump($hlist);
		
		$hostlist = array("-1"=>" ") + $hostlist;
		$this->set('hostlist',$hostlist);
		

		$criteria = array();
		if(is_numeric($eid)){//編集
			$this->set('edit', true);
			//取得条件設定
			$asso = array(
				'Employeeaccount : employeeaccounts : LEFT' => array('Employeeaccount.employee_id = Employee.id'),
				'Host : hosts : LEFT' => array('Host.id = Employeeaccount.host_id'),
				'Employeeadacc : employeeadaccs : LEFT' => array('Employeeadacc.employee_id = Employee.id'),
			) ;
			
			//取得項目
			$fields = array(
			'Employee.id',
			'Employee.id_name',
			'Employee.name',
			'Employee.group_id',
			'Employee.enabled',
			'Host.id',
			'Employeeaccount.account',
			'Employeeaccount.number',
			'Employeeadacc.account'
			);
			
			$criteria[]="Employee.id = ".$eid;
			$Employee = $this->Employee->findByAsso($criteria, $fields, 'Employeeaccount.number', null, null, $asso);
			//debug($Employee);
			
			$this->set('curtID', $Employee[0]['Employee']['id']);
			$this->set('curtIDName', $Employee[0]['Employee']['id_name']);
			$this->set('curtName', $Employee[0]['Employee']['name']);
			$this->set('curtGroup', $Employee[0]['Employee']['group_id']);
			$this->set('curtEnabled', $Employee[0]['Employee']['enabled']);
			$this->set('curtDomain', $Employee[0]['Employeeadacc']['account']);
			
			$curtHosts = array();
			$curtAccounts = array();
			$acclists = array();
			foreach($Employee as $key => $e){
				$curtHosts[$key] = $e['Host']['id'];
				$curtAccounts[$key] = $e['Employeeaccount']['account'];
				
				$accounts = $this->Hstacc->findAll(array('host_id' => $e['Host']['id']));
				$acclist = array('' => __('select_account', true));
				foreach($accounts as $acc){
					if(!empty($acc['Hstacc']['account']))
						$acclist[$acc['Hstacc']['account']] = $acc['Hstacc']['account'];
				}
				$acclists[$key] = $acclist;
			}
			$this->set('acclists', $acclists);
			$this->set('curtHosts', $curtHosts);
			$this->set('curtAccounts', $curtAccounts);

			
		}else{//追加
			$this->set('edit', false);
		
		}
		//$this->render('form');
	}
	
	function del(){
		$this->layout = 'ajax';
		//	debug($this->data['Employee']['delid']);
		if(isset($this->data['Employee']['delid'])){
			$eids  = $this->data['Employee']['delid'];
			foreach ($eids as $i => $check){
				$crit = array('employee_id ='.$check);
				$ad = $this->Employeeadacc->find($crit);
				if(!empty($ad)){
					$old = $ad['Employeeadacc']['account'];
					//以前のアカウントを記録して設定を無効化する
					$olddomain = array(
						'Oldaccount' => array(
								'account' => $this->Lv->spec_char_dbm($old),
							)
						); 						
					$this->Oldaccount->save($olddomain);
				}
				
				//削除したアカウントを記録
				$accs = $this->Employeeaccount->findAll($crit);
				if(!empty($accs)){
					foreach($accs as $acc){
						$hid = $acc['Employeeaccount']['host_id'];
						$ac = $acc['Employeeaccount']['account'];
						$this->Oldhstaccount->save(array(
									'Oldhstaccount' => array('host_id' => $hid, 'account' => $ac, 'hide' => 1, 'deleted' => 0)
								));
					}
				}
				$this->Employee->del($check);
				$this->Employeeaccount->deleteAll(array("employee_id =". $check));
				$this->Employeeadacc->deleteAll(array("employee_id =". $check));
			}
			$this->GenerateFiles->hook_by_ps(0, array('uptimeaccount','hostaccount'), 1);
		}
		$this->lists();
	}
	function activate($e = 1){
		$this->layout = 'ajax';
		
		$glist = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
		$group_ids = "";
		foreach($glist as $key => $g){
			$group_ids .= $key.",";
		}
		$group_ids = rtrim($group_ids, ","); 
		
		$enabled = 0;
		if($e == 0)
			$enabled = 0;
		else
			$enabled = 1;
		
		//	debug($this->data['Employee']['delid']);
		if(isset($this->data['Employee']['delid'])){
			$eids  = $this->data['Employee']['delid'];
			//var_dump($eids);
			foreach ($eids as $i => $check){					
				$this->Employee->updateAll(array('Employee.id = '.$check, 'Employee.group_id in ('.$group_ids.')'), array('Employee.enabled' => $enabled) );
			}
			$this->GenerateFiles->hook_by_ps(0, array('hostaccount'), 1);
		}
		$this->lists();
	}
	function add()
	{//debug($this->data);
		$this->layout = 'ajax';
		$errorMessage = array();
		
		$id = $this->data['Employee']['id'];
		$id_name = $this->Lv->spec_char_dbm($this->data['Employee']['id_name']);
		$name = $this->Lv->spec_char_dbm($this->data['Employee']['name']);
		$domainuser = $this->data['Employeeadacc']['account'];
		$group_id = $this->data['Employee']['group_id'];
		$host_ids = array();
		foreach($this->data['host_id'] as $host_id){
			$host_ids[] = $host_id;
		}
		$accounts = array();
		foreach($this->data['account'] as $account){
			$accounts[] = $this->Lv->spec_char_dbm($account);
		}
		if($this->data['Employee']['enabled'] == 1)
			$enabled = $this->data['Employee']['enabled'];
		else
			$enabled = 0;
		$errorMessage = $this->addEmployee($id, $id_name, $name, $group_id, $host_ids, $accounts, $domainuser, $enabled);

		$this->set('errorMessage', $errorMessage);
	}
	function addEmployee($id, $id_name, $name, $group_id, $host_ids, $accounts, $domain, $enabled, $check_domain = true)
	{
		$edit = false;
		$errorMessage = array();
		//echo $id;
		//debug($this->data);
		$regex = '/[<>:*?\\|]/';
		foreach($accounts as $acc){
			if (preg_match($regex, $acc)) {
				$errorMessage['account_name'][] = 'E-00800';
				break;
			}
		}
		
		if(empty($id_name)){
			$errorMessage['employee_id'][] = 'E-00100';
		}else if(empty($id)){//社員IDの重複
			$criteria = array();
			$criteria[] = "Employee.id_name = '".$this->Lv->spec_char_dbm($id_name)."'";
			$acc = $this->Employee->find($criteria);
			if(!empty($acc)){
				$errorMessage[$id_name][] = 'E-01900';
			}
		}
		if(empty($name)){
			$errorMessage['name'][] = 'E-00100';
		}
		
		
		
		//他の社員を確認
		foreach($host_ids as $num => $host_id){
			if(empty($host_id))
				continue;
			if($host_id == -1)
				continue;
			//同じPC+アカウントが設定されていないか
			$criteria = array();
			$criteria[] = "Employeeaccount.host_id =". $host_id;
			$criteria[] = "Employeeaccount.account = '".$this->Lv->spec_char_dbm($accounts[$num])."'";
			if(!empty($id)){//編集の場合
				$criteria[] = "Employeeaccount.employee_id !=".$id;
			}	
			
			$acc = $this->Employeeaccount->find($criteria);
			if(!empty($acc)){
				$host = $this->Host->find("Host.id=".$host_id);
				$errorMessage[$host['Host']['host_name']][] = 'UPE-00200';
			}
			//他のグループで同じPCが設定されていないか
			$criteria = array();
			$criteria[] = "Employee.group_id !=".$group_id;
			$criteria[] = "Employeeaccount.host_id =". $host_id;
			if(!empty($id)){//編集の場合
				$criteria[] = "Employeeaccount.employee_id !=".$id;
			}	
			$asso = array('Employee : employees' => array('Employee.id = Employeeaccount.employee_id'));
			$fld = array("Employeeaccount.account");
			$acc = $this->Employeeaccount->findByAsso($criteria, $fld, null,null,null, $asso);
			if(!empty($acc)){
				$host = $this->Host->find("Host.id=".$host_id);
				$errorMessage[$host['Host']['host_name']][] = 'UPE-00210';
			}
		}

		if(empty($domain)){
			//空でもよい
			//$errorMessage['domain'][] = 'E-00100';
		}else{//ドメインアカウントの重複
			$criteria = array();
			if(!empty($id)){//編集の場合
				$criteria[] = "Employeeadacc.employee_id != ".$id;
			}
			$criteria[] = "Employeeadacc.account = '".$this->Lv->spec_char_dbm($domain)."'";
			$acc = $this->Employeeadacc->find($criteria);
			if(!empty($acc)){
				$errorMessage[$domain][] = 'E-01900';
			}
			$regex = '/[\/\[\]:;|=,+*?<>@"]/';
			if (preg_match($regex, $domain)) {
				$errorMessage[$domain][] = 'E-00800';
			}
			
			//形式確認
			$pos = strpos($domain, "\\");
			if($pos === false)
			{
				$errorMessage[$domain][] = 'UPE-00500';
			}
			else if($check_domain){
				$check = $this->_checkAccount(array(substr($domain, $pos+1)), $cmdresult);
				if($check == 0){
					$cmdrs = explode(',', $cmdresult);
					//var_dump($cmdrs);
					if($cmdrs[0] != 0)
						$errorMessage[$domain][] = 'UPE-00150';
				}
			}
		}
		
		if(empty($errorMessage)){
			$newEmployee = array(
				'Employee' => array(
						'id_name' => $this->Lv->spec_char_dbm($id_name),
						'name' => $this->Lv->spec_char_dbm($name),
						'group_id' => $group_id,
						'enabled' => $enabled,
					)
				); 			
			if(!empty($id)){//編集の場合
				$edit = true;
				$newEmployee['Employee']['id'] = $id;
			}				
			$this->Employee->save($newEmployee);
			
			$newid = $this->Employee->getLastInsertID();
			if(!empty($id)){//編集の場合
				$newid = $id;
			}
				
			foreach($host_ids as $num => $host_id){
				if(empty($host_id))
					continue;
				$newAccount = array();
				$account = $this->Lv->spec_char_dbm($accounts[$num]);
					
				$newAccount = array(
							'Employeeaccount' => array(
								'number' => $num,
								'employee_id' => $newid,
								'host_id' => $host_id,
								'account' => $account,
								'exist' => 2
							)
						); 
				if($edit){//編集の場合
					//debug($newAccount);	
					$crit = array('employee_id ='.$newid, 'number = '.$num);
					$acc = $this->Employeeaccount->find($crit);
					if($host_id == -1){//ホストで空白を選択
						if(!empty($acc)){//以前のアカウントがあれば設定を削除
							$hid = $acc['Employeeaccount']['host_id'];
							$ac = $this->Lv->spec_char_dbm($acc['Employeeaccount']['account']);
							$this->Hsttime->deleteAll(array('host_id ='.$hid,"account ='".$ac."'"));
							
							$crit2 = array('host_id ='.$hid, "account ='".$ac."'");
							$this->Oldhstaccount->deleteAll($crit2);
							$this->Oldhstaccount->save(array(
									'Oldhstaccount' => array('host_id' => $hid, 'account' => $ac, 'hide' => 1, 'deleted' => 0)
								));
						}
						$this->Employeeaccount->deleteAll($crit);
						continue;
					}

					if(!empty($acc)){
						$exist = $acc['Employeeaccount']['exist'];
						//アカウント名orホスト名が変わったら稼働時間設定を削除
						if($acc['Employeeaccount']['account'] != $account || $acc['Employeeaccount']['host_id'] != $host_id){
							$hid = $acc['Employeeaccount']['host_id'];
							$ac = $this->Lv->spec_char_dbm($acc['Employeeaccount']['account']);
							$this->Hsttime->deleteAll(array('host_id ='.$hid,"account ='".$ac."'"));
							
							$crit2 = array('host_id ='.$hid, "account ='".$ac."'");
							$this->Oldhstaccount->deleteAll($crit2);
							$this->Oldhstaccount->save(array(
									'Oldhstaccount' => array('host_id' => $hid, 'account' => $ac, 'hide' => 1, 'deleted' => 0)
								));
							$exist = 2;//アカウント存在不明
						}
						$query = "update employeeaccounts set host_id={$host_id}, account='$account', exist={$exist} where employee_id ={$newid} and number ={$num}";
						$this->Employeeaccount->execute($query);
					}else{//前の設定は無い
						$this->Employeeaccount->save($newAccount);
					}
				}else if($host_id != -1){
					//debug($newAccount);				
					$this->Employeeaccount->save($newAccount);
				}
			}
			
			//登録しようとするアカウントを削除対象から除外
			foreach($host_ids as $num => $host_id){
				if(empty($host_id))
					continue;
				if($host_id == -1)//ホストで空白を選択
					continue;
				$account = $this->Lv->spec_char_dbm($accounts[$num]);
				$crit2 = array('host_id ='.$host_id, "account ='".$account."'");
				$this->Oldhstaccount->deleteAll($crit2);
			}
			
			
			//ドメインアカウント
			$crit = array('employee_id ='.$newid);
			$ad = $this->Employeeadacc->find($crit);
			if(!empty($ad)){
				$old = $ad['Employeeadacc']['account'];
				if($old != $domain){//以前のアカウントを記録して設定を無効化する
					$olddomain = array(
					'Oldaccount' => array(
							'account' => $this->Lv->spec_char_dbm($old),
						)
					); 						
					$this->Oldaccount->save($olddomain);
				}
				$this->Employeeadacc->deleteAll($crit);
			}
			if(!empty($domain)){
				//無効化対象から削除
				$crit = array("account ='".$this->Lv->spec_char_dbm($domain)."'", 'host_id = 0');
				$this->Oldaccount->deleteAll($crit);
				
				$newEmployeead = array(
					'Employeeadacc' => array(
							'employee_id' => $newid,
							'number' => 0,
							'account' => $this->Lv->spec_char_dbm($domain),
						)
					); 						
				$this->Employeeadacc->save($newEmployeead);
			}
			
			$this->GenerateFiles->hook_by_ps(0, array('uptimeaccount','hostaccount','uptime'), 1);
		}
		return $errorMessage;
	}
	
	function do_import()
  	{
  		require_once("csv_imports_controller.php");
  		$hear_num = 1;
		//$dataにCSVからの情報が入る
		$data = CsvImportsController :: do_import($hear_num);
		//debug($data);
		
		$errorMessage = array();
		if($data[0]!='error_csv' && $data[0]!='error_format'){
			//$errorMessage=$this->search(1,$data);
			/*foreach($data as $e){

			}*/
			empty($errorMessage)?$errorMessage=null:$errorMessage=$errorMessage;
		}else{
			$errorMessage[__('surecsv',$return = true)][] = 'E-06000';
		}
		
		if(empty($errorMessage)){
			$domains = array();
			$orgdomains = array();
			$domain_results = array();

			$count = 0;
			foreach($data as $v)
			{
				$domain = $v[9];
				if(!empty($domain)){
					$pos = strpos($domain, "\\");
					if($pos === false)
					{}else{
						$domains[] = substr($domain, $pos+1);
						$orgdomains[] = $domain;
					}
				}
			}
			
			$check = $this->_checkAccount($domains, $cmdresult);
			if($check == 0){
				$cmdrs = explode(',', $cmdresult);
				//var_dump($cmdrs);
				for($i =0; $i < count($domains); $i++){
					$domain_results[$orgdomains[$i]] = $cmdrs[$i];
				}
			}

			
			foreach($data as $v)
			{
				if (is_array($v)) 
				{
					$err = array();
					//社員ID(既にあれば変更)
					$id = null;
					$id_name = $this->Lv->spec_char_dbm($v[0]);
					$emp = $this->Employee->findByIdName($id_name);
					if(!empty($emp))
						$id = $emp['Employee']['id'];
					//氏名
					$name = $v[1];
					//グループ
					$group = $this->Group->findByGroupName($this->Lv->spec_char_dbm($v[2]));
					if(empty($group))
						$err[$v[2]][] = 'UPE-00400';//存在しない
					$group_id = $group['Group']['id'];
					//コンピュータ名
					$host_ids = array();
					for($i = 0; $i < 3; $i++ ){
						$n = 3 + ($i*2);
						if(!empty($v[$n])){
							$host = $this->Host->findByHostName($this->Lv->spec_char_dbm($v[$n]));
							if(empty($host))
								$err[$v[$n]][] = 'UPE-00300';//重複
							else
								$host_ids[] = $host['Host']['id'];
						}else
							$host_ids[] = -1;//削除
					}
					//アカウント名
					$accounts = array($this->Lv->spec_char_dbm($v[4]),
										$this->Lv->spec_char_dbm($v[6]),
										$this->Lv->spec_char_dbm($v[8]));
					//ドメインアカウント
					$domain = $v[9];
					if(!empty($domain) && array_key_exists($domain, $domain_results)){
						if($domain_results[$domain] != 0)
							$err[$domain][] = 'UPE-00150';
					}
										
					//有効化
					if(!empty($v[10]) && ( $v[10] == __('enabled', true) || $v[10] == 1))
						$enabled = 1;
					else
						$enabled = 0;

					if(empty($err)){//エラーがある行は入れない
						$msg = $this->addEmployee($id, $id_name, $name, $group_id, $host_ids, $accounts, $domain, $enabled, false);
						$errorMessage[] = $msg;
					}else
						$errorMessage[] = $err;
				}
			}

		}
		
		$this->index($errorMessage,null);
		$this->layout='uptime';
		$this->render("index");
  	}
	
	function getAccounts()
	{
		$this->layout = 'ajax';
		$acclist = array('' => __('select_account', true));
		if(!empty($this->data['host_id']))
		{
			foreach($this->data['host_id'] as $id => $host){
				$host_id = $host;
				$index = $id;
			}
			if($host_id > -1){
				//ホストのアカウントを取得
				$accounts = $this->Hstacc->findAll(array('host_id' => $host_id));
				foreach($accounts as $acc){
					if(!empty($acc['Hstacc']['account']))
						$acclist[$acc['Hstacc']['account']] = $acc['Hstacc']['account'];
				}
				$this->set('index', $index);
				$this->set('host_id', $host_id);
			}
		}
		$this->set('acclist', $acclist);
		$this->render("select");
	}

	function set_str_encoding($name)
    {
        $result= mb_convert_encoding($name,__('CharacterSet',$retrun=true),"UTF-8"); 
        return $result;
    } 
	
	function _checkAccount($accounts = array(), &$result){
		
		$ad = $this->Activedirectory->find();
		//AD設定が無い
		if(empty($ad)){
			return 2;
		}
		$domain_name  = $ad['Activedirectory']['domain_name'];
		$domain_controller  = $ad['Activedirectory']['dc'];
		$domain_admin  = $ad['Activedirectory']['adminuser'];
		$domain_password  = $ad['Activedirectory']['password'];
		
		//設定ファイル内容
		$contents = "[Config]\r\n";
		$contents .= "Type=WMI";
		$contents .= "\r\n";
		$contents .= "Mode=Account";
		$contents .= "\r\n";
		$contents .= "DomainController=".$domain_controller;
		$contents .= "\r\n";
		$contents .= "UserName=".$domain_admin;
		$contents .= "\r\n";
		$contents .= "PassWord=".$this->Lv->save_decode($domain_password);
		$contents .= "\r\n";

		$contents .= "[Target]\r\n";
		$i=0;
		foreach($accounts as $name){
			$contents .= "Account_".$i++."=".$name;
			$contents .= "\r\n";
		}

		//一時ファイル作成　BEGIN
		$filename = "ad".substr(md5(time().rand(0,1000000)),0,10) . ".ini";
		$csv_folder=ROOT.DS.APP_DIR.DS."tmp".DS."csv".DS;
		$file = $csv_folder.$filename;
		$fp = fopen($file, 'w');  

		$enc= $this->set_str_encoding($contents);
		fputs($fp, $enc);
		
		fclose($fp);
	
		//exe実行
		$v_path=(VENDORS);
		$tmpfname = "LvADCheckTool.exe";
		$wd = getcwd();
		chdir($v_path);
		$output = array();
		$result = exec( sprintf("%s \"%s\"", $tmpfname, $file), $output, $return_var);

		//一時ファイル削除
		unlink($file);
		chdir($wd);
		//var_dump( $output);
		//var_dump( $return_var);
		return $return_var;
	}
}
?>