<?php
class UptimeRecordsController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','Check');
	var $uses=array('Group', 'Host','Rlthstgrp','Grpauth','Hstalt','Authority','Rltuserauth','User','Configure','Validation',
	'Employee','Employeeaccount', 'Employeeadacc', 'Optuser', 'Timecontrol');
	var $layout='uptime';
	function beforeFilter()
	{
		parent::beforeFilter();
		$this->pageTitle =__('menu_uptime',$retrun=true); 
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		elseif(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
	}
	function index($errorMessage = null)
	{
		$glist = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
		ksort($glist);
		$this->set('glist',$glist);
		
				//グループ所属の社員ID
		$group_ids = "";
		foreach($glist as $key => $g){
			$group_ids .= $key.",";
		}
		$group_ids = rtrim($group_ids, ","); 
		$fields = array('Employee.id', 
		'concat(Employee.id_name, " ", Employee.name) as Employee__name', 
		'Employee.id_name');
		$criteria[]="Employee.group_id in (".$group_ids.")";
		$elist = $this->Employee->findAll($criteria, $fields, "Employee.id_name", null, 1);
		if(!empty($elist)){
			$keys = Set::extract($elist, '{n}.Employee.id');
			$vals = Set::extract($elist, '{n}.Employee.name');
			$elist = array_combine($keys, $vals);
		}
		$elist = array(""=>"全て") + $elist;
		//debug($elist);
		$this->set('elist',$elist);
	}
	
	function search($type=null)
	{
		$this->layout="ajax";
		//debug($this->data);
		$group_id = $this->data['Employee']['group_id'];
		$emp_id = $this->data['Employee']['id'];
		
		$criteria[] = "1=1";
		
		//開始時間、時間外の判定
		$defaults = $this->getDefault($group_id);
		//debug($defaults);
		$times = "";
		foreach($defaults as $gid => $def){
			$start = "00:00:00";
			if(!empty($def['Timecontrol']['start_day']))
				$start = $def['Timecontrol']['start_day'];
			$by_dt = $this->Lv->optionsDatetime4($start);
			$time = implode(' and ', $by_dt)." and (Employee.group_id = ".$gid." or Employeead.group_id = ".$gid.")";
			$times .= "(".$time.") or";
		}
		$times = rtrim($times, "or"); 
		if(strlen($times) > 0)
			$criteria[] = "(".$times .")";
		else
			$criteria[] = "1=2";
		
	/*	$start = "00:00:00";
		$by_dt = $this->Lv->optionsDatetime4($start);
		//debug($by_dt);
		$criteria[] = implode(' and ', $by_dt);*/
		
		$glist = $this->Grpauth->getChildrenByParent($group_id);
		$group_ids = "";
		foreach($glist as $key => $g){
			$group_ids .= $key.",";
		}
		$group_ids = rtrim($group_ids, ","); 
		$criteria[] = "(Employee.group_id in (". $group_ids.") or Employeead.group_id in (". $group_ids."))";

		
		if(!empty($emp_id))
			$criteria[] = "(Employee.id =". $emp_id." or Employeead.id =". $emp_id.")";
		//$criteria[] = "(Employeeaccount.account is null OR Employeeaccount.account = Optuser.account)";
		$criteria[] = "Optuser.log_status in (1,2)";
		$criteria[] = "Optuser.AccessFrom = ''";
		$criteria['GROUP BY'] = "Optuser.host_id, Optuser.account, Optuser.domain, DATE_FORMAT(SUBTIME(Optuser.tslog, '$start'), '%Y%m%d')";
		//Optuser.log_status, 
		$asso = array(
		'Host : hosts' => array('Optuser.host_id = Host.id'),
		'Employeeaccount : employeeaccounts : left' => array(
			'Employeeaccount.host_id = Optuser.host_id',
			'Employeeaccount.account = Optuser.account'),
		'Employee : employees : left' => array('Employeeaccount.employee_id = Employee.id'),
		'Group : groups : left' => array('Group.id = Employee.group_id'),
		//ad
		//'Employeeadacc : employeeadaccs : left' => array('Employeeadacc.account = Optuser.account'),
		'Employeeadacc : employeeadaccs : left' => array(
			"Employeeadacc.account like concat(Optuser.domain,'%\\\',Optuser.account)"),
		'Employeead : employees : left' => array('Employeeadacc.employee_id = Employeead.id'),
		'Groupad : groups : left ' => array('Groupad.id = Employeead.group_id'),

		);
		//0:shutdown 1:logon 2:logoff
		$fields = array(
		'date(min(Optuser.tslog)) as Optuser__date',
		'min(case when log_status = 1 then Optuser.tslog else "9999-01-01 00:00:00" end) as Optuser__in_min',
		'max(case when log_status = 2 or log_status = 0 then Optuser.tslog else "0000-01-01 00:00:00" end) as Optuser__out_max',
	'max(case when log_status = 1 then Optuser.tslog else "0000-01-01 00:00:00" end) as Optuser__in_max',
	'min(case when log_status = 2 or log_status = 0 then Optuser.tslog else "9999-01-01 00:00:00" end) as Optuser__out_min',	//	'Group.group_name as Group__group_name',
		'(case when Group.group_name is null then Groupad.group_name else Group.group_name end) as Group__group_name',
		'Host.host_name as Host__host_name',
		'Host.id as Host__id',
	'sum(case when log_status = 1 then 1 else 0 end) as Optuser__in_count',
	'sum(case when log_status = 2 then 1 else 0 end) as Optuser__out_count',

	//	'Optuser.account as Optuser__account',
		'(case when Employeeadacc.account is null then Optuser.account else Employeeadacc.account end) as Optuser__account',
	//	'Employee.id_name as Employee__id_name',
	//	'Employee.name as Employee__name',
		'(case when Employee.id_name is null then Employeead.id_name else Employee.id_name end) as Employee__id_name',
		'(case when Employee.name is null then Employeead.name else Employee.name end) as Employee__name',
		'(case when Employee.group_id is null then Employeead.group_id else Employee.group_id end) as Employee__group_id',
		);
		//$this->Pagination->show = 1;//100
		if($type=='csv'){
			$data = $this->Optuser->findByAsso($criteria, $fields, 'Optuser__date, Group.group_name, Employee__id_name, Host.host_name', null, null, $asso);
		}else{
			list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'search', 'url'=>'/uptime_records/search/', 'modelClass'=>'Optuser', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 
			'sortBy' => $this->Lv->sortBy('Optuser__date, Group.group_name, Employee__id_name, Host.host_name')));
			$data = $this->Optuser->findByAsso($criteria, $fields, $order, $limit, $page, $asso);
		}
		
		//debug($data);
		$data2 = array();
		$week = array("日", "月", "火", "水", "木", "金", "土");
		foreach($data as $record){
			$tmp = $record;
            //最初がログイン
			if( $tmp['Optuser']['in_min'] < $record['Optuser']['out_min']){
				//最後がログアウト
				if($tmp['Optuser']['in_max'] < $record['Optuser']['out_max']){
					if($tmp['Optuser']['in_count'] > $record['Optuser']['out_count']){//ログインが多い
						$tmp['Optuser']['start'] = date('H:i', strtotime($record['Optuser']['in_min']));
						$tmp['Optuser']['start_long'] = $record['Optuser']['in_min'];
						$tmp['Optuser']['end'] = "";
					}else if($tmp['Optuser']['in_count'] < $record['Optuser']['out_count']){//ログアウトが多い
						$tmp['Optuser']['start'] = "";
						$tmp['Optuser']['end'] = date('H:i', strtotime($record['Optuser']['out_max']));
						$tmp['Optuser']['end_long'] = $record['Optuser']['out_max'];
					}else{//同じ
						$tmp['Optuser']['start'] = date('H:i', strtotime($record['Optuser']['in_min']));
						$tmp['Optuser']['start_long'] = $record['Optuser']['in_min'];
						$tmp['Optuser']['end'] = date('H:i', strtotime($record['Optuser']['out_max']));
						$tmp['Optuser']['end_long'] = $record['Optuser']['out_max'];
					}
				}else{ //最後がログイン
					if($tmp['Optuser']['in_count'] > $record['Optuser']['out_count']){//ログインが多い
						$tmp['Optuser']['start'] = date('H:i', strtotime($record['Optuser']['in_min']));
						$tmp['Optuser']['start_long'] = $record['Optuser']['in_min'];
						$tmp['Optuser']['end'] = "";
					}else if($tmp['Optuser']['in_count'] < $record['Optuser']['out_count']){//ログアウトが多い
						$tmp['Optuser']['start'] = "";
						$tmp['Optuser']['end'] = "";
					}else{//同じ
						$tmp['Optuser']['start'] = "";
						$tmp['Optuser']['end'] = "";
					}
				}
			}else{//最初がログアウト
				$tmp['Optuser']['start'] = "";
				$tmp['Optuser']['end'] = "";
				//最後がログアウト
				if($tmp['Optuser']['in_max'] < $record['Optuser']['out_max']){
					if($tmp['Optuser']['in_count'] < $record['Optuser']['out_count']){//ログアウトが多い
						$tmp['Optuser']['end'] = date('H:i', strtotime($record['Optuser']['out_max']));
						$tmp['Optuser']['end_long'] = $record['Optuser']['out_max'];
					}
				}
			}
			/*
			if($record['Optuser']['in_min'] == "9999-01-01 00:00:00")
				$tmp['Optuser']['start'] ="";
			else{
				$tmp['Optuser']['start'] = date('H:i', strtotime($record['Optuser']['in_min']));
				$tmp['Optuser']['start_long'] = $record['Optuser']['in_min'];
			}
			if($record['Optuser']['out_max'] == "0000-01-01 00:00:00")
				$tmp['Optuser']['end'] ="";
			else{
				$tmp['Optuser']['end'] = date('H:i', strtotime($record['Optuser']['out_max']));
				$tmp['Optuser']['end_long'] = $record['Optuser']['out_max'];
			}*/
			$tmp['Optuser']['date'] = $record['Optuser']['date'];
			$w = date('w', strtotime($record['Optuser']['date']));
			$tmp['Optuser']['weekday'] = $week[$w];
			
			$data2[] = $tmp;
		}
	
		foreach($data2 as &$record){
			if(empty($record['Optuser']['start']) || empty($record['Optuser']['end']))
				$record['Optuser']['out'] = '○';//true;
			else{
				//一日の開始時刻
				$deftime = $defaults[$record['Employee']['group_id']];

				//就業時間
				$startWork = "";
				$endWork = "";
				if(!empty($deftime['Timecontrol']['start_work']))
					$startWork = $deftime['Timecontrol']['start_work'];
				if(!empty($deftime['Timecontrol']['end_work']))
					$endWork = $deftime['Timecontrol']['end_work'];
				$startstr = date("H:i", strtotime($startWork) );
				$endstr = date("H:i", strtotime($endWork) );
		
				//$time = date('H:i' , strtotime($record['Optuser']['start']));
				//$time2 = date('H:i' , strtotime($record['Optuser']['end']));
				
				$add = 0;
				if($startstr > $endstr)
					$add = 1;
				
				$start = strtotime($record['Optuser']['date']." ".$startstr);
				$end = strtotime($record['Optuser']['date']." ".$endstr.' +'.$add.' days');
				/*
				echo date('Y-m-d H:i:s',$start)."<br/>";
				echo date('Y-m-d H:i:s',$end)."<br/>";
				echo $record['Optuser']['start_long']."<br/>";
				echo $record['Optuser']['end_long']."<br/>";
				*/
				if($start  <= strtotime($record['Optuser']['start_long']) && strtotime($record['Optuser']['end_long']) <= $end)
					$record['Optuser']['out'] = "";//false;
				else
					$record['Optuser']['out'] = '○';//true;
			}
		}
		//debug($this->data);
		if($type=='csv')
		{
			$this->csvdown($data2);exit();
		}		
		
		
		$this->set('data', $data2);

	}
	
	function csvdown($data = array())
	{
		require_once( 'csv/DlFactory.php' );
		$csv = DlFactory::create("uptime_records");
		if(isset($this->data["Employee"]["group_id"])){
			$this->data["Employee"]["group_name"] = $this->groupName($this->data["Employee"]["group_id"]);
		}
		
		if(isset($this->data["Employee"]["id"])){
			$this->data["Employee"]["id_name"] = $this->employeeName($this->data["Employee"]["id"]);
		}
			
		$csv->sendCSVFile($data,$this->data, __('record_csv',$return = true));
		exit;
	}
	
	function groupName($group_id)
	{
		$criteria=" Group.id=".$group_id." ";
		$group_n= $this->Group->findAll($criteria);
		$group_name = $group_n[0]["Group"]["group_name"];
		return $group_name;
	}
	
	function employeeName($emp_id)
	{
		$criteria[]="Employee.id =".$emp_id;
		$elist = $this->Employee->findAll($criteria, array('concat(Employee.id_name, " ", Employee.name) as Employee__name'), null, null, 1);
		return $elist[0]['Employee']['name'];
	}
	
	//グループの基本設定を取得　無い場合は親の設定を取得
	function getTimecontrol($groupid)
	{
		$default = $this->Timecontrol->find(array("group_id" => $groupid));
		if(empty($default))
		{
			$parent = $this->Group->group_father_id($groupid);
			if(!empty($parent))
				$default = $this->getTimecontrol($parent);
		}
		return $default;
	}
	
	//グループごとの基本設定取得
	function getDefault($parent)
	{
		$glist = $this->Grpauth->getChildrenByParent($parent);
		$defaults = array();
		foreach($glist as $gid => $gname)
		{
			$default = $this->getTimecontrol($gid);
			$defaults[$gid] = $default;
		}
		return $defaults;
	}
}
?>